# MINDTCT Minutiae Detector Integration
- Included in this folder is an unix executable for the minutiae detector (mindtct). This exectuable is compiled from the [nbis repository](https://github.com/lessandro/nbis)
- The extractor will output several files, the relavant one is extention ".min". This file can be read by import-test.sh to convert coordinates, angle and reliability score to json format and there is logic in the php to save to the database
## Issues as of 8/21/2024 
- Able to run extractor using php exec() calls and collect detected minutiae using a shell script to convert the values to json format, and add to standalone database tables. 
- Ran into issues copying the extraction data from the extraction tables into the pianos system, as there are several connected functions and fragile code regarding the saveResults() process in AppDB.php.
- Either need to rewrite logic and code for saving annotations and minutiae based off x, y, angle and type data, or replicate the current client-to-server json format and branch off existing logic.  
- Somehow, the front-end generates an unique database id for each new minutiae placed before being sent back to server in json format when clicking "Save", need to figure out how this occurs. No extra requests appear to go out before saving, it is unclear where the code for this is. Reccomend that Marco De Donno takes this on. 
## For future devs:
- It could be possible to reuse saveResults() function in AppDB.php to save initial extracted minutiae values. This work is started in getOrCreateAssignment() function in AppDB.php. 
